#include "windows.h"
// basic file operations
//#include <iostream>
#include <fstream>
#include <string>
//#include <sstream>
#include <time.h>
#include <tchar.h>
#include <algorithm>
#define _tWinMain   wWinMain
#include "./freeimage/FreeImage.h"
#pragma comment(lib, "./freeimage/FreeImage.lib")
using namespace std;

void trace(wstring s) {
	MessageBox(NULL,s.c_str(),L"Trace",0);
}

wchar_t* ConvertToWideChar(char* p) {
	wchar_t *r;
	r = new wchar_t[strlen(p)+1];

	char *tempsour = p;
	wchar_t *tempdest = r;
	while(*tempdest++=*tempsour++);

	return r;
}

LPSTR UnicodeToAnsi(wstring str) {

	LPCWSTR s = str.c_str();

	if (s==NULL) return NULL;
	int cw=lstrlenW(s);
	if (cw==0) {CHAR *psz=new CHAR[1];*psz='\0';return psz;}
	int cc=WideCharToMultiByte(CP_ACP,0,s,cw,NULL,0,NULL,NULL);
	if (cc==0) return NULL;
	CHAR *psz=new CHAR[cc+1];
	cc=WideCharToMultiByte(CP_ACP,0,s,cw,psz,cc,NULL,NULL);
	if (cc==0) {delete[] psz;return NULL;}
	psz[cc]='\0';
	return psz;
}


void JPEGtoBMP(string strSrc, string strTar) {

	FREE_IMAGE_FORMAT    fif;

	fif = FreeImage_GetFIFFromFilename(strSrc.c_str());
	FIBITMAP* m_handleFI = FreeImage_Load(fif, strSrc.c_str());


	fif = FreeImage_GetFIFFromFilename(strTar.c_str());
	FreeImage_Save(fif, m_handleFI, strTar.c_str());
}


wstring *paths = new wstring[10];
bool ReadCFG() {
	unsigned int size;
	char* memblock;
	ifstream file ("config.cfg", ios::in|ios::binary|ios::ate);

	if (file.is_open())
	{
		size = (int)file.tellg();
		memblock = new char[size];
		file.seekg (0, ios::beg);
		file.read (memblock, size);
		file.close();

		wstring str = ConvertToWideChar(memblock);
		delete[] memblock;
		if(str.empty()) return false;

		unsigned int pos = (int)str.find('\n',0);
		paths[0] = str.substr(0, pos-1);
		unsigned int in=pos;
		unsigned int i=1;

		while( in<str.length() ) {

			pos = (int)str.find('\n',in+1);
			if(pos==wstring::npos) {
				if(in+1<str.length()) paths[i] = str.substr(in+1, str.length()-(in+1));
				in=str.length();
			} else paths[i] = str.substr(in+1, (pos-1)-(in+1));
			in=pos;

			++i;
		}

		return true;

	}
	return false;
}

int CountFiles(wstring dir) {
	dir += L"/*";
	WIN32_FIND_DATA FindFileData;
	HANDLE hFind = FindFirstFile(dir.c_str(), &FindFileData);

	wstring ext;
	unsigned int count = 0;
	unsigned int i =0;
	while (FindNextFile(hFind, &FindFileData) != 0) 
	{
		i=0;
		if(FindFileData.dwFileAttributes!=FILE_ATTRIBUTE_DIRECTORY) {
			ext = FindFileData.cFileName;
			ext = ext.substr(ext.rfind('.')+1,ext.length()-1);
			transform(ext.begin(), ext.end(),ext.begin(),towupper);
			//while(i<ext.length()) ext[i]=toupper(ext[i++]);
			//trace(ext);
			if(ext.compare(L"BMP")==0 ||
				ext.compare(L"JPG")==0 ||
				ext.compare(L"JPEG")==0) count++;
		}
	}
	return count;
}

void SetWallpaper(__w64 unsigned long nr) {
	unsigned short j = 0;
	unsigned long i = 0;
	WIN32_FIND_DATA FindFileData;
	HANDLE hFind = FindFirstFile((paths[j]+L"/*.jpg;*.jpeg;*.bmp").c_str(), &FindFileData);
	while(i!=nr) {
		++i;
		if(FindNextFile(hFind, &FindFileData) == 0) {
			++j;
			if(paths[j].empty()) return;
			hFind = FindFirstFile((paths[j]+L"/*").c_str(), &FindFileData);
		} else if(FindFileData.dwFileAttributes==FILE_ATTRIBUTE_DIRECTORY) {
			--i;
			continue;
		}
	}

	//trace(paths[j]+"\\"+FindFileData.cFileName);
	string memblock = UnicodeToAnsi((paths[j]+L"\\"+FindFileData.cFileName));
	JPEGtoBMP(memblock,"C:/wallpaper.bmp");
	SystemParametersInfo( SPI_SETDESKWALLPAPER, 0, L"C:/wallpaper.bmp", SPIF_UPDATEINIFILE );

	ofstream file ("C:/wall.txt",ios::binary|ios::trunc);

	if (file.is_open())
	{
		file.write(memblock.c_str(),memblock.size());
		file.close();
	}

}

/*
template <class T>
inline std::string ToString (const T& t)
{
std::stringstream ss;
ss << t;
return ss.str();
}
*/

int APIENTRY wWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{

	if( ReadCFG() ) {
		unsigned long count = 0;
		int i=0;
		while(!paths[i].empty()) {
			count += CountFiles(paths[i]);
			++i;
		}

		//trace(ToString(count));
		if(count<1) trace(L"No images found");
		else {
			srand(time(NULL));
			__w64 unsigned long nr =  (time(NULL)*rand()) % count;
			SetWallpaper(nr);
		}
		//trace(ToString(nr));

	} else trace(L"\"config.cfg\" file not found or is empty!");


	delete[] paths;

	return 0;
}